const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ApprovalsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const approvals = await db.approvals.create(
      {
        id: data.id || undefined,

        object_type: data.object_type || null,
        object_id: data.object_id || null,
        step: data.step || null,
        status: data.status || null,
        timestamp: data.timestamp || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await approvals.setApprover(data.approver || null, {
      transaction,
    });

    await approvals.setOrganizations(data.organizations || null, {
      transaction,
    });

    return approvals;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const approvalsData = data.map((item, index) => ({
      id: item.id || undefined,

      object_type: item.object_type || null,
      object_id: item.object_id || null,
      step: item.step || null,
      status: item.status || null,
      timestamp: item.timestamp || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const approvals = await db.approvals.bulkCreate(approvalsData, {
      transaction,
    });

    // For each item created, replace relation files

    return approvals;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const approvals = await db.approvals.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.object_type !== undefined)
      updatePayload.object_type = data.object_type;

    if (data.object_id !== undefined) updatePayload.object_id = data.object_id;

    if (data.step !== undefined) updatePayload.step = data.step;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.timestamp !== undefined) updatePayload.timestamp = data.timestamp;

    updatePayload.updatedById = currentUser.id;

    await approvals.update(updatePayload, { transaction });

    if (data.approver !== undefined) {
      await approvals.setApprover(
        data.approver,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await approvals.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return approvals;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const approvals = await db.approvals.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of approvals) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of approvals) {
        await record.destroy({ transaction });
      }
    });

    return approvals;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const approvals = await db.approvals.findByPk(id, options);

    await approvals.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await approvals.destroy({
      transaction,
    });

    return approvals;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const approvals = await db.approvals.findOne({ where }, { transaction });

    if (!approvals) {
      return approvals;
    }

    const output = approvals.get({ plain: true });

    output.approver = await approvals.getApprover({
      transaction,
    });

    output.organizations = await approvals.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'approver',

        where: filter.approver
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.approver
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.approver
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.object_type) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('approvals', 'object_type', filter.object_type),
        };
      }

      if (filter.object_idRange) {
        const [start, end] = filter.object_idRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            object_id: {
              ...where.object_id,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            object_id: {
              ...where.object_id,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.stepRange) {
        const [start, end] = filter.stepRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            step: {
              ...where.step,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            step: {
              ...where.step,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.timestampRange) {
        const [start, end] = filter.timestampRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.approvals.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('approvals', 'object_type', query),
        ],
      };
    }

    const records = await db.approvals.findAll({
      attributes: ['id', 'object_type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['object_type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.object_type,
    }));
  }
};
